VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TextStore"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Event Change()
Attribute Change.VB_MemberFlags = "200"

Private varText As String

Public Property Get Value() As String
Attribute Value.VB_UserMemId = 0
Value = varText
End Property

Public Property Let Value(ByVal NewText As String)
varText = NewText
RaiseEvent Change
End Property

Public Sub SetText(ByVal NewText As String)
varText = NewText
RaiseEvent Change
End Sub

Private Sub Class_Initialize()
#If DEBUG_MODE Then
If DEBUG_FILE > 0 Then Print #DEBUG_FILE, "TextStore + :: " & ObjPtr(Me)
#End If
varText = vbNullString
End Sub

Private Sub Class_Terminate()
varText = vbNullString
#If DEBUG_MODE Then
If DEBUG_FILE > 0 Then Print #DEBUG_FILE, "TextStore - :: " & ObjPtr(Me)
#End If
End Sub

Public Sub Clear()
varText = vbNullString
RaiseEvent Change
End Sub

Public Sub Insert(ByVal Text As String, Optional ByVal InsertBefore As Long)
Dim L1 As Long, L2 As Long
L1 = Len(varText)
If InsertBefore = 0 Or InsertBefore > L1 Then InsertBefore = L1 + 1
If InsertBefore = L1 + 1 Then
  varText = varText & Text
Else
  L2 = Len(Text)
  varText = varText & String$(L2, 0)
  Mid$(varText, InsertBefore + L2, L1 - InsertBefore + 1) = Mid$(varText, InsertBefore, L1 - InsertBefore + 1)
  Mid$(varText, InsertBefore, L2) = Text
End If
RaiseEvent Change
End Sub

Public Sub Trim(ByVal From As Long, Optional ByVal Length As Long)
Dim L0 As Long, L As Long
L = Len(varText)
If From = 0 Or From > L Then Exit Sub
L0 = L - From + 1
If Length = 0 Or Length > L0 Then Length = L0
Mid$(varText, From, L0 - Length) = Mid$(varText, From + Length, L0 - Length)
RaiseEvent Change
End Sub

Public Sub Subst(ByVal Text As String, ByVal PosFrom As Long, Optional ByVal Length As Long, Optional ByVal PosTo As Long)
Dim L0 As Long, L As Long, DL As Long
If Length = 0 Then
  If PosTo = 0 Then
    Length = Len(Text)
  Else
    Length = PosTo - PosFrom + 1
  End If
End If
L0 = Len(varText)
L = Len(Text)
DL = L - Length
Select Case DL
  Case Is = 0
    Mid$(varText, PosFrom, L) = Text
  Case Is < 0
    Mid$(varText, PosFrom, L) = Text
    Mid$(varText, PosFrom + L, L0 - (PosFrom + Length) + 1) = Mid$(varText, PosFrom + Length, L0 - (PosFrom + Length) + 1)
    varText = Left$(varText, L0 + DL)
  Case Is > 0
    varText = varText & String$(DL, vbNullChar)
    Mid$(varText, PosFrom + L, L0 - (PosFrom + Length) + 1) = Mid$(varText, PosFrom + Length, L0 - (PosFrom + Length) + 1)
    Mid$(varText, PosFrom, L) = Text
End Select
RaiseEvent Change
End Sub

Public Function Length() As Long
Length = Len(varText)
End Function

Public Function Mid1(ByVal Pos As Long, ByVal Length As Long) As String
Mid1 = Mid$(varText, Pos, Length)
End Function

Public Function Mid2(ByVal PosFrom As Long, ByVal PosTo As Long) As String
If PosTo < PosFrom Then Exit Function
Mid2 = Mid$(varText, PosFrom, PosTo - PosFrom + 1)
End Function

Public Function Mid3(ByVal PosFromEnd As Long, ByVal Length As Long) As String
Mid3 = Mid$(varText, Len(varText) - PosFromEnd, Length)
End Function
